	TITLE	Window.c
	.386P
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
PUBLIC	_g_szClassName
CONST	SEGMENT
_g_szClassName DB 'myWindowClass', 00H
CONST	ENDS
_DATA	SEGMENT
$SG42500 DB	'Error!', 00H
	ORG $+1
$SG42501 DB	'Window Registration Failed!', 00H
$SG42507 DB	'The title of my window', 00H
	ORG $+1
$SG42511 DB	'Error!', 00H
	ORG $+1
$SG42512 DB	'Window Creation Failed!', 00H
_DATA	ENDS
PUBLIC	_WndProc@16
EXTRN	__imp__DefWindowProcA@16:NEAR
EXTRN	__imp__PostQuitMessage@4:NEAR
EXTRN	__imp__DestroyWindow@4:NEAR
_TEXT	SEGMENT
_hwnd$ = 8
_msg$ = 12
_wParam$ = 16
_lParam$ = 20
_WndProc@16 PROC NEAR

; 8    :     switch(msg)
; 9    :     {

	mov	ecx, DWORD PTR _msg$[esp-4]
	mov	eax, ecx
	sub	eax, 2
	je	SHORT $L42469
	sub	eax, 14					; 0000000eH
	je	SHORT $L42468

; 15   :         break;
; 16   :         default:
; 17   :             return DefWindowProc(hwnd, msg, wParam, lParam);

	mov	eax, DWORD PTR _lParam$[esp-4]
	mov	edx, DWORD PTR _wParam$[esp-4]
	push	eax
	mov	eax, DWORD PTR _hwnd$[esp]
	push	edx
	push	ecx
	push	eax
	call	DWORD PTR __imp__DefWindowProcA@16

; 20   : }

	ret	16					; 00000010H
$L42468:

; 10   :         case WM_CLOSE:
; 11   :             DestroyWindow(hwnd);

	mov	ecx, DWORD PTR _hwnd$[esp-4]
	push	ecx
	call	DWORD PTR __imp__DestroyWindow@4

; 18   :     }
; 19   :     return 0;

	xor	eax, eax

; 20   : }

	ret	16					; 00000010H
$L42469:

; 12   :         break;
; 13   :         case WM_DESTROY:
; 14   :             PostQuitMessage(0);

	push	0
	call	DWORD PTR __imp__PostQuitMessage@4

; 18   :     }
; 19   :     return 0;

	xor	eax, eax

; 20   : }

	ret	16					; 00000010H
_WndProc@16 ENDP
_TEXT	ENDS
PUBLIC	_WinMain@16
EXTRN	__imp__UpdateWindow@4:NEAR
EXTRN	__imp__GetMessageA@16:NEAR
EXTRN	__imp__TranslateMessage@4:NEAR
EXTRN	__imp__DispatchMessageA@4:NEAR
EXTRN	__imp__MessageBoxA@16:NEAR
EXTRN	__imp__RegisterClassExA@4:NEAR
EXTRN	__imp__CreateWindowExA@48:NEAR
EXTRN	__imp__ShowWindow@8:NEAR
EXTRN	__imp__LoadCursorA@8:NEAR
EXTRN	__imp__LoadIconA@8:NEAR
_TEXT	SEGMENT
_hInstance$ = 8
_nCmdShow$ = 20
_wc$ = -48
_Msg$ = -76
_WinMain@16 PROC NEAR

; 24   : {

	sub	esp, 76					; 0000004cH
	push	ebx
	push	esi

; 25   :     WNDCLASSEX wc;
; 26   :     HWND hwnd;
; 27   :     MSG Msg;
; 28   : 
; 29   :     //Step 1: Registering the Window Class
; 30   :     wc.cbSize        = sizeof(WNDCLASSEX);
; 31   :     wc.style         = 0;
; 32   :     wc.lpfnWndProc   = WndProc;
; 33   :     wc.cbClsExtra    = 0;
; 34   :     wc.cbWndExtra    = 0;
; 35   :     wc.hInstance     = hInstance;
; 36   :     wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);

	mov	esi, DWORD PTR __imp__LoadIconA@8
	push	edi
	mov	edi, DWORD PTR _hInstance$[esp+84]
	xor	ebx, ebx
	push	32512					; 00007f00H
	push	ebx
	mov	DWORD PTR _wc$[esp+96], 48		; 00000030H
	mov	DWORD PTR _wc$[esp+100], ebx
	mov	DWORD PTR _wc$[esp+104], OFFSET FLAT:_WndProc@16
	mov	DWORD PTR _wc$[esp+108], ebx
	mov	DWORD PTR _wc$[esp+112], ebx
	mov	DWORD PTR _wc$[esp+116], edi
	call	esi

; 37   :     wc.hCursor       = LoadCursor(NULL, IDC_ARROW);

	push	32512					; 00007f00H
	push	ebx
	mov	DWORD PTR _wc$[esp+120], eax
	call	DWORD PTR __imp__LoadCursorA@8

; 38   :     wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
; 39   :     wc.lpszMenuName  = NULL;
; 40   :     wc.lpszClassName = g_szClassName;
; 41   :     wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

	push	32512					; 00007f00H
	push	ebx
	mov	DWORD PTR _wc$[esp+124], eax
	mov	DWORD PTR _wc$[esp+128], 6
	mov	DWORD PTR _wc$[esp+132], ebx
	mov	DWORD PTR _wc$[esp+136], OFFSET FLAT:_g_szClassName
	call	esi
	mov	DWORD PTR _wc$[esp+132], eax

; 42   : 
; 43   :     if(!RegisterClassEx(&wc))

	lea	eax, DWORD PTR _wc$[esp+88]
	push	eax
	call	DWORD PTR __imp__RegisterClassExA@4
	test	ax, ax
	jne	SHORT $L42498

; 44   :     {
; 45   :         MessageBox(NULL, "Window Registration Failed!", "Error!",
; 46   :             MB_ICONEXCLAMATION | MB_OK);

	push	48					; 00000030H
	push	OFFSET FLAT:$SG42500
	push	OFFSET FLAT:$SG42501
	push	ebx
	call	DWORD PTR __imp__MessageBoxA@16
	pop	edi
	pop	esi

; 47   :         return 0;

	xor	eax, eax
	pop	ebx

; 76   : }

	add	esp, 76					; 0000004cH
	ret	16					; 00000010H
$L42498:

; 48   :     }
; 49   : 
; 50   :     // Step 2: Creating the Window
; 51   :     hwnd = CreateWindowEx(
; 52   :         WS_EX_CLIENTEDGE,
; 53   :         g_szClassName,
; 54   :         "The title of my window",
; 55   :         WS_OVERLAPPEDWINDOW,
; 56   :         CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
; 57   :         NULL, NULL, hInstance, NULL);

	push	ebx
	push	edi
	push	ebx
	push	ebx
	push	120					; 00000078H
	push	240					; 000000f0H
	push	-2147483648				; 80000000H
	push	-2147483648				; 80000000H
	push	13565952				; 00cf0000H
	push	OFFSET FLAT:$SG42507
	push	OFFSET FLAT:_g_szClassName
	push	512					; 00000200H
	call	DWORD PTR __imp__CreateWindowExA@48
	mov	esi, eax

; 58   : 
; 59   :     if(hwnd == NULL)

	cmp	esi, ebx
	jne	SHORT $L42509

; 60   :     {
; 61   :         MessageBox(NULL, "Window Creation Failed!", "Error!",
; 62   :             MB_ICONEXCLAMATION | MB_OK);

	push	48					; 00000030H
	push	OFFSET FLAT:$SG42511
	push	OFFSET FLAT:$SG42512
	push	ebx
	call	DWORD PTR __imp__MessageBoxA@16
	pop	edi
	pop	esi

; 63   :         return 0;

	xor	eax, eax
	pop	ebx

; 76   : }

	add	esp, 76					; 0000004cH
	ret	16					; 00000010H
$L42509:

; 64   :     }
; 65   : 
; 66   :     ShowWindow(hwnd, nCmdShow);

	mov	ecx, DWORD PTR _nCmdShow$[esp+84]
	push	ecx
	push	esi
	call	DWORD PTR __imp__ShowWindow@8

; 67   :     UpdateWindow(hwnd);

	push	esi
	call	DWORD PTR __imp__UpdateWindow@4

; 68   : 
; 69   :     // Step 3: The Message Loop
; 70   :     while(GetMessage(&Msg, NULL, 0, 0) > 0)

	mov	esi, DWORD PTR __imp__GetMessageA@16
	push	ebx
	push	ebx
	push	ebx
	lea	edx, DWORD PTR _Msg$[esp+100]
	push	edx
	call	esi
	test	eax, eax
	jle	SHORT $L42516
	mov	edi, DWORD PTR __imp__TranslateMessage@4
	push	ebp
	mov	ebp, DWORD PTR __imp__DispatchMessageA@4
$L42515:

; 71   :     {
; 72   :         TranslateMessage(&Msg);

	lea	eax, DWORD PTR _Msg$[esp+92]
	push	eax
	call	edi

; 73   :         DispatchMessage(&Msg);

	lea	ecx, DWORD PTR _Msg$[esp+92]
	push	ecx
	call	ebp
	push	ebx
	push	ebx
	push	ebx
	lea	edx, DWORD PTR _Msg$[esp+104]
	push	edx
	call	esi
	test	eax, eax
	jg	SHORT $L42515
	pop	ebp
$L42516:

; 74   :     }
; 75   :     return Msg.wParam;

	mov	eax, DWORD PTR _Msg$[esp+96]
	pop	edi
	pop	esi
	pop	ebx

; 76   : }

	add	esp, 76					; 0000004cH
	ret	16					; 00000010H
_WinMain@16 ENDP
_TEXT	ENDS
include Cstart.asm
END
